# kylin-scanner

## Summary
**kylin-scanner** is a user-friendly scanning software developed with Qt5. 
It provides functions of hot plug detection, ordinary scanning, one click beautification, intelligent deviation correction and character recognition.
At the same time, it also includes the functions of toolbar cutting, rotation, watermark, horizontal flip and so on.

<br>

## Main interface

The main interface has simple functions, mainly including scanning setting page and default scanner connection status page.

<br>

![Figure 1 Main-interface-big](image/main.png)

<br>

## Detection scanner equipment

After the scanning software is opened, it will automatically detect the scanner connected directly through USB or set up network connection.

<br>
**Note:  the scanner has a corresponding USB cable. Mixed use will lead to unknown errors, such as IO errors.**

<br>

![Figure 2 Detection scanner equipment interface-big](image/detect-wait.png)

<br>

## Scanner device not detected

When multiple scanning devices are not detected, the scanning device not detected page appears. 
When the scanner is connected to the machine through USB direct connection or network, it can be connected again by clicking the "connect scanner" button.

<br>

![Figure 3 scanner device not detected-big](image/detect-fail.png)

<br>

## Scanner device detected

When the scanning device is detected, the scanning device has been detected, and the following initialization operation interface will appear. 
At this time, the default scanning device is selected, and the parameters of the default scanning device are obtained and displayed in the interface.

The functions of sending mail and saving as are unavailable. When a document is scanned, it becomes available.

<br>

![Figure 4 scanner device detected-big](image/detect-success.png)

<br>

## Switch scanning device

Switch scanning devices when multiple scanning devices are detected, you can switch scanning devices through the scanning setting page. 
When the scanning device is switched, the scanning parameters will be obtained again and the parameters in the scanning setting page will be updated.

Such as device name, number of pages, type, color, resolution, name and other parameters.

<br>

![Figure 5 switching scanning equipment-big](image/switch-device.png)

<br>

## Scanner settings

The scanner setup page can set the following parameters:
- 1) Scanning equipment
- 2) Page Scanned
- 3) Delay interval for multi page scanning
- 4) Scan type
- 5) Scan color
- 6) Scanning resolution
- 7) Scan size
- 8) Scan format
- 9) Scan name
- 10) Scan storage directory
- 11) Send mail
- 12) Save as

<br>

### Set number of scanned pages

On the scan setting page, you can set the number of scanned pages, which can be set as "single page scan" and "multi page scan".

Parameter interpretation:

"Single page scan" parameter: only one scan can be performed. After the scan, it will not be scanned automatically.

"Multi page scan" parameter: multiple scans can be performed. After the first scan, the next scan can be performed according to the set delay interval until the user automatically ends the scan or encounters abnormal conditions.

Common exceptions include: no scannable document in the scanner, scanning parameter error, scanning IO error, etc.

<br>

### Set the delay interval for multi page scanning

Set the delay interval of multi page scanning. The parameter represents the interval time during multiple scanning. The optional parameters are: 3 seconds, 5 seconds, 7 seconds, 10 seconds and 15 seconds.

<br>

### Set scan type

Scanning type means scanning according to different scanner types. This parameter is obtained by selecting the specified scanner. The optional parameters are: flat plate type and paper feeding type.

Among them, the paper feeding type can be subdivided into ADF front, ADF back and ADF double-sided.

There are different scanner types for different scanners, as follows:

1. Only flat type is supported: Canon Lide 210, Canon Lide 300, Canon Lide 400, etc;

2. Support paper feed: HP Officejet_ 250_ Mobile_ Series, etc;

3. Both flat panel and paper feed support: HP color LaserJet Pro MFP m281fdw, etc.

<br>

### Set scan resolution

Different scanner resolutions can be set. This parameter is also obtained according to the specified scanner. 
The optional resolutions are: 75， 100， 150， 200， 300， 600， 1200， 2400.

**Note: ** 
the higher the resolution, the longer the scanning time, and the larger the memory occupied by the scanned pictures. 
The later image processing operation will be too slow to load properly. Therefore, when the user selects a resolution greater than 600 for scanning, there will be a corresponding prompt. 

<br>

### Set scan size

Obtain the specific scanning size from the scanner equipment selected by the user. The optional parameters are A4, A5 and A6.

Different scanners have different scanning areas, such as * * Fujitsu fi-7140 * * the scanner starts scanning in the middle area.

**Canon Lide 400 * * the scanner starts scanning in the left area.

<br>

### Set scan format

Different scan formats can be set to store scanned documents. The optional parameters are: JPG,  PNG,  PDF,  BMP.

<br>

### Set scan to directory

Set the initial saving path of scanned documents. The default is "pictures / kylin scanner images" in the home directory.

<br>

### Start scanning

Click the "start scanning" button to set different scanning parameters for scanning operation.

<br>

### Send mail

After scanning, you can send the scanned document to the installed mail client of the system.

<br>

### Save as

After scanning or editing the scanned document, you can save the scanned document as a file in different formats.

<br>

## toolbar
Icons and their functions:

| Icon | Function description |
| :--------: | :---------: |
| ![](image/beauty.svg) | One click beautification | 
| ![](image/rectify.svg) |	Intelligent deviation correction |
| ![](image/ocr.svg) | Character recognition |
| ![](image/crop.svg) |	Cutting |
| ![](image/rotate.svg) | rotate |
| ![](image/mirror.svg) | Mirror flip |
| ![](image/watermark.svg) | Add watermark |
| ![](image/zoomout.svg) | narrow |
| ![](image/zoomin.svg) | enlarge |

<br>

### One click beautification

After scanning, you can beautify the scanned document with one click, including saturation, contrast and sharpening.

<br>

### Intelligent deviation correction

After scanning, the scanned document can be intelligently corrected for subsequent character recognition operations.

<br>

### Character recognition

After scanning, you can perform character recognition on the scanned document. Before the character recognition operation, 
the document can be intelligently corrected first, so that the highly corrected document recognition effect is better.

<br>

### Cutting

After scanning, you can cut the document and select the appropriate document area.

<br>

### rotate

After scanning, you can rotate the document.

<br>

### Mirror flip

After scanning, you can mirror and flip the document.

<br>

### Add watermark

After scanning, you can add watermark to the document.

<br>

