# 扫描

## 概述
扫描是一款用户友好，使用Qt5进行开发的扫描软件，提供热插拔检测、普通扫描、一键美化、智能纠偏和文字识别功能。
同时还包括了工具栏的裁切、旋转、水印、水平翻转等功能。

<br>

## 主界面

主界面功能简洁，主要有扫描设置页面和默认扫描仪连接状态页面。

<br>

![图 1 主界面-big](image/main.png)

<br>

## 检测扫描仪设备

扫描软件打开后，就会自动检测通过USB直连或者设置网络连接的扫描仪。

<br>
**注：扫描仪有对应的USB线，混用会导致不可知的错误，比如io错误。**

<br>

![图 2 检测扫描仪设备界面-big](image/detect-wait.png)

<br>

## 未检测到扫描仪设备

当未检测到多个扫描设备时，出现未检测到扫描设备页面。当扫描仪通过USB直连或者网络连接到机器上时，可以通过点击“连接扫描仪”按钮进行再次连接。

<br>

![图 3 未检测到扫描仪设备-big](image/detect-fail.png)

<br>

## 已检测到扫描仪设备

当检测扫描设备结束时，已检测到扫描设备，会出现如下初始化操作界面。此时，已选中默认扫描设备，并获取了该默认扫描设备的参数显示在该界面。
发送邮件和另存为功能都不可用，当扫描出文档，可变为可用状态。

<br>

![图 4 已检测到扫描仪设备-big](image/detect-success.png)

<br>

## 切换扫描设备

当检测到多个扫描设备时，可以通过扫描设置页面进行切换扫描设备。切换扫描设备时，会重新获取扫描参数，进行更新扫描设置页面中的参数。
如设备名、页数、类型、颜色、分辨率和名称等参数。

<br>

![图 5 切换扫描设备-big](image/switch-device.png)

<br>

## 扫描仪设置

扫描仪设置页面可以进行以下参数设置：
- 1) 扫描设备
- 2) 扫描页数
- 3) 多页扫描的延时间隔
- 4) 扫描类型
- 5) 扫描颜色
- 6) 扫描分辨率
- 7) 扫描尺寸
- 8) 扫描格式
- 9) 扫描名称
- 10) 扫描存储目录
- 11) 发送邮件
- 12) 另存为

<br>

### 设置扫描页数

在扫描设置页面，可以设置扫描页数，可设置为“单页扫描”和“多页扫描”两种参数。
参数解释：
“单页扫描”参数：只能进行一次扫描，扫描结束后，不自动扫描。
“多页扫描”参数：可以进行多次扫描，当第一次扫描结束后，可以根据设置的延时间隔进行下一次扫描，直到用户自动结束扫描或遇到异常情况。
常见异常情况有：扫描仪中无可扫描文档、扫描参数错误、扫描io错误等。

<br>

### 设置多页扫描的延时间隔

设置多页扫描的延时间隔参数代表多次扫描期间间隔的时间，可选参数有：3秒、5秒、7秒、10秒、15秒。

<br>

### 设置扫描类型

扫描类型代表按照不同的扫描仪类型进行扫描。该参数是根据选择指定的扫描仪进行获取的，可选参数有：平板式和馈纸式。
其中，馈纸式又可细分为ADF正面、ADF背面和ADF双面三类。

针对不同的扫描仪有不同的扫描仪类型，如下：
1. 只支持平板式：Canon lide 210, Canon lide 300, Canon lide 400 等；
2. 支持馈纸式：hp OfficeJet_250_Mobile_series 等；
3. 平板式和馈纸式都支持：hp Color LaserJet Pro MFP M281fdw 等。

<br>

### 设置扫描分辨率

可以设置不同扫描仪分辨率，该参数也是根据指定扫描仪进行获取，可选分辨率有： 75， 100， 150， 200， 300， 600， 1200， 2400。

**注：** 
越高分辨率，扫描时长越长，扫描出的图片所占内存越大，后期的图像处理操作会有适当加载过慢现象，所以用户选择大于600的分辨率进行扫描时，会有对应提示。

<br>

### 设置扫描尺寸

从用户选定的扫描仪设备获取具体的扫描尺寸，可选参数为：A4， A5, A6。

不同扫描仪存在不同的扫描区域，比如**FUJITSU fi-7140**扫描仪是居中区域开始扫描。

**Canon lide 400**扫描仪是居左区域开始扫描。

<br>

### 设置扫描格式

可设置不同的扫描格式用于存储扫描的文档。可选参数为：jpg, png, pdf, bmp。

<br>

### 设置扫描至目录

设置扫描文档的初始保存路径，默认为家目录下的“图片/kylin-scanner-images”。

<br>

### 开始扫描

点击“开始扫描”按钮，可以设置不同的扫描参数进行扫描操作。

<br>

### 发送邮件

扫描完成后，可以将扫描文档通过系统已安装的邮件客户端进行发送邮件。

<br>

### 另存为

扫描完成或通过对扫描文档编辑操作后，可以将扫描文档另存为不同格式的文件。

<br>

## 工具栏
图标及其功能:

| 图标 | 功能说明 |
| :--------: | :---------: |
| ![](image/beauty.svg) | 一键美化 | 
| ![](image/rectify.svg) |	智能纠偏 |
| ![](image/ocr.svg) | 文字识别 |
| ![](image/crop.svg) |	裁切 |
| ![](image/rotate.svg) | 旋转 |
| ![](image/mirror.svg) | 镜像翻转 |
| ![](image/watermark.svg) | 添加水印 |
| ![](image/zoomout.svg) | 缩小 |
| ![](image/zoomin.svg) | 放大 |

<br>

### 一键美化

扫描完成后，可以对扫描文档进行一键美化，包括饱和度、对比度和锐化等美化。

<br>

### 智能纠偏

扫描完成后，可以对扫描文档进行智能纠偏，以便之后的文字识别操作。

<br>

### 文字识别

扫描完成后，可以对扫描文档进行文字识别操作。在文字识别操作前，可以对文档先进行智能纠偏，这样高度纠偏的文档识别效果更好。

<br>

### 裁切

扫描完成后，可以对文档进行裁切，选取合适的文档区域。

<br>

### 旋转

扫描完成后，可以对文档进行旋转。

<br>

### 镜像翻转

扫描完成后，可以对文档进行镜像翻转。

<br>

### 添加水印

扫描完成后，可以对文档进行添加水印操作。

<br>

